<template>
  <div class="tenant">
    <byTable
      :source="sourceList.data"
      :pagination="sourceList.pagination"
      :config="config"
      :loading="loading"
      :selectConfig="selectConfig"
      highlight-current-row
      :action-list="[
        {
          text: '新建样品单',
          action: () => newSample(),
        },
      ]"
      @get-list="getList">
      <template #amount="{ item }">
        <div>
          <span style="padding-right: 4px">{{ item.currency }}</span>
          <span>{{ moneyFormat(item.amount, 2) }}</span>
        </div>
      </template>
      <template #advanceRatio="{ item }">
        <div>
          <span>{{ item.advanceRatio }}%</span>
        </div>
      </template>
    </byTable>

    <el-dialog title="交接单" v-if="openHandoverSlip" v-model="openHandoverSlip" width="600">
      <byForm :formConfig="formConfig" :formOption="formOption" v-model="handoverSlipForm">
        <template #file>
          <div style="width: 100%">
            <el-upload
              v-model:fileList="handoverSlipForm.fileList"
              action="https://winfaster.obs.cn-south-1.myhuaweicloud.com"
              :data="uploadData"
              multiple
              :before-upload="uploadFile"
              :on-success="handleSuccess"
              :on-preview="onPreviewFile">
              <el-button type="primary" plain>选择</el-button>
            </el-upload>
          </div>
        </template>
        <template #indication>
          <div style="width: 100%">
            <el-upload
              v-model:fileList="handoverSlipForm.packageFileList"
              action="https://winfaster.obs.cn-south-1.myhuaweicloud.com"
              :data="indicationUploadData"
              multiple
              :before-upload="indicationUploadFile"
              :on-success="handleSuccess"
              :on-preview="onPreviewFile">
              <el-button type="primary" plain>选择</el-button>
            </el-upload>
          </div>
        </template>
      </byForm>
      <template #footer>
        <el-button @click="openHandoverSlip = false" size="large">关 闭</el-button>
        <el-button type="primary" @click="submitHandoverSlip()" size="large">确 定</el-button>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import { computed, ref } from "vue";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import useUserStore from "@/store/modules/user";
import { ElMessage, ElMessageBox } from "element-plus";

const { proxy } = getCurrentInstance();
const accountCurrency = ref([]);
const tradeMethods = ref([]);
const corporationList = ref([]);
const customerList = ref([]);
const userList = ref([]);
const shippingMethod = ref([]);
const status = ref([
  {
    label: "草稿",
    value: 0,
  },
  {
    label: "审批中",
    value: 10,
  },
  {
    label: "驳回",
    value: 20,
  },
  {
    label: "审批通过",
    value: 30,
  },
  {
    label: "终止",
    value: 99,
  },
]);
const sourceList = ref({
  data: [],
  pagination: {
    total: 0,
    pageNum: 1,
    pageSize: 10,
    keyword: "",
    status: "",
    sellCorporationId: "",
  },
});
const loading = ref(false);
const selectConfig = computed(() => {
  return [
    {
      label: "审批状态",
      prop: "status",
      data: status.value,
    },
    {
      label: "归属公司",
      prop: "sellCorporationId",
      data: corporationList.value,
    },
  ];
});
const config = computed(() => {
  return [
    {
      attrs: {
        label: "样品单编号",
        prop: "code",
        width: 180,
      },
    },
    {
      attrs: {
        label: "归属公司",
        prop: "sellCorporationId",
        "min-width": 220,
      },
      render(type) {
        return proxy.dictValueLabel(type, corporationList.value);
      },
    },
    {
      attrs: {
        label: "业务员",
        prop: "createUser",
        width: 140,
      },
      render(type) {
        return proxy.dictValueLabel(type, userList.value);
      },
    },
    {
      attrs: {
        label: "下单时间",
        prop: "createTime",
        width: 160,
      },
    },
    {
      attrs: {
        label: "客户名称",
        prop: "buyCorporationId",
        "min-width": 220,
      },
      render(type) {
        return proxy.dictValueLabel(type, customerList.value);
      },
    },
    {
      attrs: {
        label: "合同金额",
        slot: "amount",
        width: 140,
      },
    },
    {
      attrs: {
        label: "预付比例",
        slot: "advanceRatio",
        width: 140,
      },
    },
    {
      attrs: {
        label: "审批状态",
        prop: "status",
        width: 140,
      },
      render(type) {
        return proxy.dictValueLabel(type, status.value);
      },
    },
    {
      attrs: {
        label: "操作",
        width: 140,
        align: "center",
        fixed: "right",
      },
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "交接单",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              clickHandoverSlip(row);
            },
          },
          {
            attrs: {
              label: "作废",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              ElMessageBox.confirm("此操作将永久删除该数据, 是否继续?", "提示", {
                confirmButtonText: "确定",
                cancelButtonText: "取消",
                type: "warning",
              }).then(() => {
                proxy
                  .post("/sample/edit", {
                    id: row.id,
                    status: 88,
                  })
                  .then(() => {
                    ElMessage({
                      message: "作废成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});
const getDict = () => {
  proxy.getDictOne(["trade_methods", "account_currency", "shipping_method"]).then((res) => {
    tradeMethods.value = res["trade_methods"].map((x) => ({
      label: x.dictValue,
      value: x.dictKey,
    }));
    accountCurrency.value = res["account_currency"].map((x) => ({
      label: x.dictValue,
      value: x.dictKey,
    }));
    shippingMethod.value = res["shipping_method"].map((x) => ({
      label: x.dictValue,
      value: x.dictKey,
    }));
  });
  proxy.post("/corporation/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    corporationList.value = res.rows.map((item) => {
      return {
        ...item,
        label: item.name,
        value: item.id,
      };
    });
  });
  proxy.post("/customer/page", { pageNum: 1, pageSize: 999 }).then((res) => {
    customerList.value = res.rows.map((item) => {
      return {
        ...item,
        label: item.name,
        value: item.id,
      };
    });
  });
  proxy
    .get("/tenantUser/list", {
      pageNum: 1,
      pageSize: 10000,
      tenantId: useUserStore().user.tenantId,
    })
    .then((res) => {
      userList.value = res.rows.map((item) => {
        return {
          label: item.nickName,
          value: item.userId,
        };
      });
    });
};
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy.post("/sample/page", sourceList.value.pagination).then((res) => {
    sourceList.value.data = res.rows;
    sourceList.value.pagination.total = res.total;
    setTimeout(() => {
      loading.value = false;
    }, 200);
  });
};
getDict();
getList();
const newSample = () => {
  proxy.$router.replace({
    path: "/platform_manage/process/processApproval",
    query: {
      flowKey: "sample_flow",
      flowName: "样品单审批流程",
      random: proxy.random(),
      tenantType: "EHSD",
    },
  });
};
const openHandoverSlip = ref(false);
const handoverSlipForm = ref({
  id: "",
  code: "",
  buyCorporationName: "",
  fileList: [],
  packageFileList: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const formConfig = computed(() => {
  return [
    {
      type: "input",
      prop: "code",
      label: "样品单编号",
      itemType: "text",
      disabled: true,
    },
    {
      type: "input",
      prop: "buyCorporationName",
      label: "客户名称",
      itemType: "text",
      disabled: true,
    },
    {
      type: "slot",
      slotName: "file",
      label: "交接单",
    },
    {
      type: "slot",
      slotName: "indication",
      label: "包装指示",
    },
  ];
});
const uploadData = ref({});
const indicationUploadData = ref({});
const clickHandoverSlip = (item) => {
  handoverSlipForm.value.id = item.id;
  handoverSlipForm.value.code = item.code;
  handoverSlipForm.value.buyCorporationName = item.buyCorporationName;
  if (item.fileInfoVos && item.fileInfoVos.length > 0) {
    handoverSlipForm.value.fileList = item.fileInfoVos.map((item) => {
      return {
        raw: item,
        name: item.fileName,
        url: item.fileUrl,
      };
    });
  } else {
    handoverSlipForm.value.fileList = [];
  }
  if (item.packageFileInfoVOList && item.packageFileInfoVOList.length > 0) {
    handoverSlipForm.value.packageFileList = item.packageFileInfoVOList.map((item) => {
      return {
        raw: item,
        name: item.fileName,
        url: item.fileUrl,
      };
    });
  } else {
    handoverSlipForm.value.packageFileList = [];
  }
  openHandoverSlip.value = true;
};
const uploadFile = async (file) => {
  const res = await proxy.post("/fileInfo/getSing", { fileName: file.name });
  uploadData.value = res.uploadBody;
  file.id = res.id;
  file.fileName = res.fileName;
  file.fileUrl = res.fileUrl;
  file.uploadState = true;
  return true;
};
const indicationUploadFile = async (file) => {
  const res = await proxy.post("/fileInfo/getSing", { fileName: file.name });
  indicationUploadData.value = res.uploadBody;
  file.id = res.id;
  file.fileName = res.fileName;
  file.fileUrl = res.fileUrl;
  file.uploadState = true;
  return true;
};
const handleSuccess = (any, UploadFile) => {
  UploadFile.raw.uploadState = false;
};
const onPreviewFile = (file) => {
  window.open(file.raw.fileUrl, "_blank");
};
const submitHandoverSlip = () => {
  if (handoverSlipForm.value.fileList && handoverSlipForm.value.fileList.length > 0) {
    for (let i = 0; i < handoverSlipForm.value.fileList.length; i++) {
      if (handoverSlipForm.value.fileList[i].raw.uploadState) {
        return ElMessage("文件上传中,请稍后提交");
      }
    }
  }
  if (handoverSlipForm.value.packageFileList && handoverSlipForm.value.packageFileList.length > 0) {
    for (let i = 0; i < handoverSlipForm.value.packageFileList.length; i++) {
      if (handoverSlipForm.value.packageFileList[i].raw.uploadState) {
        return ElMessage("文件上传中,请稍后提交");
      }
    }
  }
  let data = proxy.deepClone(handoverSlipForm.value);
  if (data.fileList && data.fileList.length > 0) {
    data.fileList = data.fileList.map((item) => {
      return {
        id: item.raw.id,
        fileName: item.raw.fileName,
        fileUrl: item.raw.fileUrl,
      };
    });
  } else {
    data.fileList = [];
  }
  if (data.packageFileList && data.packageFileList.length > 0) {
    data.packageFileList = data.packageFileList.map((item) => {
      return {
        id: item.raw.id,
        fileName: item.raw.fileName,
        fileUrl: item.raw.fileUrl,
      };
    });
  } else {
    data.packageFileList = [];
  }
  proxy.post("/sample/sampleHandover", data).then(() => {
    ElMessage({
      message: "操作成功！",
      type: "success",
    });
    openHandoverSlip.value = false;
    getList();
  });
};
</script>

<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
::v-deep(.el-input-number .el-input__inner) {
  text-align: left;
}
.baseRow {
  min-height: 24px;
  border-top: 1px solid black;
  border-left: 1px solid black;
}
.contentRow {
  border-right: 1px solid black;
  line-height: 24px;
  padding-left: 4px;
}
</style>
